/*
 * gc global variable provides access to GUI Composer infrastructure components and project information.
 * For more information, please see the Working with Javascript guide in the online help.
 */
var gc = gc || {};
gc.services = gc.services || {};


newCommand = '';

/*
*  Boilerplate code for creating computed data bindings
*/
document.addEventListener('gc-databind-ready', function() 
{
    

    gc.databind.registry.bind('widget.ti_widget_slider_gain.value', 'ti_model_streaming.xyz', function(value) {
        debugger; 
    }, function(value) {
        console.log(value);
        newCommand = "ga" + ti_widget_slider_gain.value;
        sendComm(newCommand);
       
    });
     gc.databind.registry.bind('widget.ti_widget_slider_gain2.value', 'ti_model_streaming.xyz', function(value) {
        debugger; 
    }, function(value) {
        console.log(value);
        newCommand = "ga" + ti_widget_slider_gain2.value;
        sendComm(newCommand);
       
    });
     gc.databind.registry.bind('widget.ti_widget_slider_gain3.value', 'ti_model_streaming.xyz', function(value) {
        debugger; 
    }, function(value) {
        console.log(value);
        newCommand = "ga" + ti_widget_slider_gain3.value;
        sendComm(newCommand);
       
    });
     gc.databind.registry.bind('widget.ti_widget_slider_gain4.value', 'ti_model_streaming.xyz', function(value) {
        debugger; 
    }, function(value) {
        console.log(value);
        newCommand = "ga" + ti_widget_slider_gain4.value;
        sendComm(newCommand);
       
    });
     gc.databind.registry.bind('widget.ti_widget_slider_gain5.value', 'ti_model_streaming.xyz', function(value) {
        debugger; 
    }, function(value) {
        console.log(value);
        newCommand = "ga" + ti_widget_slider_gain5.value;
        sendComm(newCommand);
       
    });
     gc.databind.registry.bind('widget.ti_widget_slider_gain6.value', 'ti_model_streaming.xyz', function(value) {
        debugger; 
    }, function(value) {
        console.log(value);
        newCommand = "ga" + ti_widget_slider_gain6.value;
        sendComm(newCommand);
       
    });
     gc.databind.registry.bind('widget.ti_widget_slider_gain7.value', 'ti_model_streaming.xyz', function(value) {
        debugger; 
    }, function(value) {
        console.log(value);
        newCommand = "ga" + ti_widget_slider_gain7.value;
        sendComm(newCommand);
       
    });
     gc.databind.registry.bind('widget.ti_widget_slider_gain8.value', 'ti_model_streaming.xyz', function(value) {
        debugger; 
    }, function(value) {
        console.log(value);
        newCommand = "ga" + ti_widget_slider_gain8.value;
        sendComm(newCommand);
       
    });


    
    
    /* 
	*   Add custom computed value databindings here, using the following method:
	*
    *   function gc.databind.registry.bind(targetBinding, modelBinding, [getter], [setter]);
	*
	*   param targetBinding - single binding string or expression, or array of binding strings for multi-way binding.
	*   param modelBinding - single binding string or expression, or array of binding strings for multi-way binding.
	*   param getter - (optional) - custom getter function for computing the targetBinding value(s) based on modelBinding value(s).
	*   param setter - (optional) - custom setter function for computing the modelBinding value(s) based on targetBinding value(s).
    */
	
	// For example, a simple computed values based on simple expression
	// gc.databind.registry.bind('widget.id.propertyName', "targetVariable == 1 ? 'binding is one' : 'binding is not one'");
	
	// Or a custom two-way binding with custome getter and setter functions.  (setter is optional)  (getter only indicates one-way binding)
	// gc.databind.registry.bind('widget.id.propertyName', "targetVariable", function(value) { return value*5/9 + 32; }, function(value) { (return value-32)*9/5; });
	
	// Event 1 to n bindings
	/* 
    gc.databind.registry.bind('widget.date.value', 
        // dependant bindings needed in order to compute the date, in name/value pairs.
        {
            weekday: 'widget.dayOfWeek.selectedText',
            day: 'widget.dayOfMonth.value',
            month: 'widget.month.selectedText',
            year: 'widget.year.value'
        }, 
        // getter for date computation
        function(values) 
        {
            // compute and return the string value to bind to the widget with id 'date'
            return values.weekday + ', ' + values.month + ' ' + values.day + ', ' + values.year;
        }
    ); 
	*/
});

/*
*  Boilerplate code for creating custom actions
*/
document.addEventListener('gc-nav-ready', function() 
{
    
    
    /* 
	*   Add custom actions for menu items using the following api:
	*
    *   function gc.nav.registryAction(id, runable, [isAvailable], [isVisible]);
	*
	*   param id - uniquely identifies the action, and should correspond to the action property of the menuaction widget.
	*   param runable - function that performs the custom action.
	*   param isAvailable - (optional) - function called when the menu action is about to appear.  Return false to disable the action, or true to enable it.
	*   param isVisible - (optional) - function called when the menu action is about to appear.  Return false to hide the action, or true to make it visible.
    */
    
	
	// For example,
	// gc.nav.registerAction('myCustomCloseAction', function() { window.close(); }, function() { return true; }, function() { return true; });
	
	// Alternatively, to programmatically disable a menu action at any time use:
	// gc.nav.disableAction('myCustomCloseAction);    then enable it again using:  gc.nav.enableAction('myCustomCloseAction'); 
});

/*
*  Boilerplate code for working with components in the application gist
*/


var initComplete = false;
var templateObj;

// Wait for DOMContentLoaded event before trying to access the application template
var init = function() {
    templateObj = document.querySelector('#template_obj');

    // Wait for the template to fire a dom-change event to indicate that it has been 'stamped'
    // before trying to access components in the application.
	templateObj.addEventListener('dom-change',function(){
	    if (initComplete) return;
	    this.async(function(){
    	    initComplete = true;
    	    console.log("Application template has been stamped.");
  	        // Now that the template has been stamped, you can use 'automatic node finding' $ syntax to access widgets.
  	        // e.g. to access a widget with an id of 'widget_id' you can use templateObj.$.widgetId


    templateObj.$.ti_widget_tabcontainer.onclick = function(){
          windowVis();
    };
    
    
    
    templateObj.$.ti_widget_checkbox_unity.onclick = function() {
    	if (ti_widget_checkbox_unity.checked === true)
        {
        console.log('Unity gain set');
        newCommand = 'ga0';
        }
        else
        {
        console.log('Unity gain removed');
        newCommand = "ga" + ti_widget_slider_gain.value;
        }
        
        sendComm(newCommand);
    };
    templateObj.$.ti_widget_checkbox_unity2.onclick = function() {
    	if (ti_widget_checkbox_unity2.checked === true)
        {
        console.log('Unity gain set');
        newCommand = 'ga0';
        }
        else
        {
        console.log('Unity gain removed');
        newCommand = "ga" + ti_widget_slider_gain2.value;
        }
        
        sendComm(newCommand);
    };
    templateObj.$.ti_widget_checkbox_unity3.onclick = function() {
    	if (ti_widget_checkbox_unity3.checked === true)
        {
        console.log('Unity gain set');
        newCommand = 'ga0';
        }
        else
        {
        console.log('Unity gain removed');
        newCommand = "ga" + ti_widget_slider_gain3.value;
        }
        
        sendComm(newCommand);
    };
    templateObj.$.ti_widget_checkbox_unity4.onclick = function() {  //from here
    	if (ti_widget_checkbox_unity4.checked === true)
        {
        console.log('Unity gain set');
        newCommand = 'ga0';
        }
        else
        {
        console.log('Unity gain removed');
        newCommand = "ga" + ti_widget_slider_gain4.value;
        }
        
        sendComm(newCommand);
    };
    templateObj.$.ti_widget_checkbox_unity5.onclick = function() {
    	if (ti_widget_checkbox_unity5.checked === true)
        {
        console.log('Unity gain set');
        newCommand = 'ga0';
        }
        else
        {
        console.log('Unity gain removed');
        newCommand = "ga" + ti_widget_slider_gain5.value;
        }
        
        sendComm(newCommand);
    };
    templateObj.$.ti_widget_checkbox_unity6.onclick = function() {
    	if (ti_widget_checkbox_unity6.checked === true)
        {
        console.log('Unity gain set');
        newCommand = 'ga0';
        }
        else
        {
        console.log('Unity gain removed');
        newCommand = "ga" + ti_widget_slider_gain6.value;
        }
        
        sendComm(newCommand);
    };
    templateObj.$.ti_widget_checkbox_unity7.onclick = function() {
    	if (ti_widget_checkbox_unity7.checked === true)
        {
        console.log('Unity gain set');
        newCommand = 'ga0';
        }
        else
        {
        console.log('Unity gain removed');
        newCommand = "ga" + ti_widget_slider_gain7.value;
        }
        
        sendComm(newCommand);
    };
    templateObj.$.ti_widget_checkbox_unity8.onclick = function() {
    	if (ti_widget_checkbox_unity8.checked === true)
        {
        console.log('Unity gain set');
        newCommand = 'ga0';
        }
        else
        {
        console.log('Unity gain removed');
        newCommand = "ga" + ti_widget_slider_gain8.value;
        }
        
        sendComm(newCommand);
    };
    


    templateObj.$.ti_widget_checkbox_DC_servo.onclick = function() {
    	  DC_send(ti_widget_checkbox_DC_servo);
    };
    templateObj.$.ti_widget_checkbox_DC_servo2.onclick = function() {
    	  DC_send(ti_widget_checkbox_DC_servo2);
    };
    templateObj.$.ti_widget_checkbox_DC_servo3.onclick = function() {
    	  DC_send(ti_widget_checkbox_DC_servo3);
    };
    templateObj.$.ti_widget_checkbox_DC_servo4.onclick = function() {
    	  DC_send(ti_widget_checkbox_DC_servo4);
    };
     templateObj.$.ti_widget_checkbox_DC_servo5.onclick = function() {
    	  DC_send(ti_widget_checkbox_DC_servo5);
    };
     templateObj.$.ti_widget_checkbox_DC_servo6.onclick = function() {
    	  DC_send(ti_widget_checkbox_DC_servo6);
    };
    templateObj.$.ti_widget_checkbox_DC_servo7.onclick = function() {
    	  DC_send(ti_widget_checkbox_DC_servo7);
    };
    templateObj.$.ti_widget_checkbox_DC_servo8.onclick = function() {
    	  DC_send(ti_widget_checkbox_DC_servo8);
    };
    
    
    
    templateObj.$.ti_widget_checkbox_CM_servo.onclick = function() {
    	  CM_send(ti_widget_checkbox_CM_servo);
    };
    templateObj.$.ti_widget_checkbox_CM_servo2.onclick = function() {
    	  CM_send(ti_widget_checkbox_CM_servo2);
    };
    templateObj.$.ti_widget_checkbox_CM_servo3.onclick = function() {
    	  CM_send(ti_widget_checkbox_CM_servo3);
    };
    templateObj.$.ti_widget_checkbox_CM_servo4.onclick = function() {
    	  CM_send(ti_widget_checkbox_CM_servo4);
    };
    templateObj.$.ti_widget_checkbox_CM_servo5.onclick = function() {
    	  CM_send(ti_widget_checkbox_CM_servo5);
    };
    templateObj.$.ti_widget_checkbox_CM_servo6.onclick = function() {
    	  CM_send(ti_widget_checkbox_CM_servo6);
    };
    templateObj.$.ti_widget_checkbox_CM_servo7.onclick = function() {
    	  CM_send(ti_widget_checkbox_CM_servo7);
    };
    templateObj.$.ti_widget_checkbox_CM_servo8.onclick = function() {
    	  CM_send(ti_widget_checkbox_CM_servo8);
    };
    
    
    
    templateObj.$.ti_widget_droplist_overload.onchange = function() {
    	  Overload_send(ti_widget_droplist_overload);
    };
    templateObj.$.ti_widget_droplist_overload2.onchange = function() {
    	  Overload_send(ti_widget_droplist_overload2);
    };
    templateObj.$.ti_widget_droplist_overload3.onchange = function() {
    	  Overload_send(ti_widget_droplist_overload3);
    };
    templateObj.$.ti_widget_droplist_overload4.onchange = function() {
    	  Overload_send(ti_widget_droplist_overload4);
    };
    templateObj.$.ti_widget_droplist_overload5.onchange = function() {
    	  Overload_send(ti_widget_droplist_overload5);
    };
    templateObj.$.ti_widget_droplist_overload6.onchange = function() {
    	  Overload_send(ti_widget_droplist_overload6);
    };
    templateObj.$.ti_widget_droplist_overload7.onchange = function() {
    	  Overload_send(ti_widget_droplist_overload7);
    };
    templateObj.$.ti_widget_droplist_overload8.onchange = function() {
    	  Overload_send(ti_widget_droplist_overload8);
    };
    

    
     templateObj.$.ti_widget_checkbox_GPO1.onclick = function() {
        GPO1_send(ti_widget_checkbox_GPO1);
    };
    templateObj.$.ti_widget_checkbox_GPO1_2.onclick = function() {
        GPO1_send(ti_widget_checkbox_GPO1_2);
    };
    templateObj.$.ti_widget_checkbox_GPO1_3.onclick = function() {
        GPO1_send(ti_widget_checkbox_GPO1_3);
    };
    templateObj.$.ti_widget_checkbox_GPO1_4.onclick = function() {
        GPO1_send(ti_widget_checkbox_GPO1_4);
    };
    templateObj.$.ti_widget_checkbox_GPO1_5.onclick = function() {
        GPO1_send(ti_widget_checkbox_GPO1_5);
    };
    templateObj.$.ti_widget_checkbox_GPO1_6.onclick = function() {
        GPO1_send(ti_widget_checkbox_GPO1_6);
    };
    templateObj.$.ti_widget_checkbox_GPO1_7.onclick = function() {
        GPO1_send(ti_widget_checkbox_GPO1_7);
    };
    templateObj.$.ti_widget_checkbox_GPO1_8.onclick = function() {
        GPO1_send(ti_widget_checkbox_GPO1_8);
    };
    
    
    
     templateObj.$.ti_widget_checkbox_GPO2.onclick = function() {
        GPO2_send(ti_widget_checkbox_GPO2);
    };
    templateObj.$.ti_widget_checkbox_GPO2_2.onclick = function() {
        GPO2_send(ti_widget_checkbox_GPO2_2);
    };
    templateObj.$.ti_widget_checkbox_GPO2_3.onclick = function() {
        GPO2_send(ti_widget_checkbox_GPO2_3);
    };
    templateObj.$.ti_widget_checkbox_GPO2_4.onclick = function() {
        GPO2_send(ti_widget_checkbox_GPO2_4);
    };
    templateObj.$.ti_widget_checkbox_GPO2_5.onclick = function() {
        GPO2_send(ti_widget_checkbox_GPO2_5);
    };
    templateObj.$.ti_widget_checkbox_GPO2_6.onclick = function() {
        GPO2_send(ti_widget_checkbox_GPO2_6);
    };
    templateObj.$.ti_widget_checkbox_GPO2_7.onclick = function() {
        GPO2_send(ti_widget_checkbox_GPO2_7);
    };
    templateObj.$.ti_widget_checkbox_GPO2_8.onclick = function() {
        GPO2_send(ti_widget_checkbox_GPO2_8);
    };
    
    
    
    templateObj.$.ti_widget_checkbox_GPO3.onclick = function() {
        GPO3_send(ti_widget_checkbox_GPO3);
    };
    templateObj.$.ti_widget_checkbox_GPO3_2.onclick = function() {
        GPO3_send(ti_widget_checkbox_GPO3_2);
    };
    templateObj.$.ti_widget_checkbox_GPO3_3.onclick = function() {
        GPO3_send(ti_widget_checkbox_GPO3_3);
    };
    templateObj.$.ti_widget_checkbox_GPO3_4.onclick = function() {
        GPO3_send(ti_widget_checkbox_GPO3_4);
    };
    templateObj.$.ti_widget_checkbox_GPO3_5.onclick = function() {
        GPO3_send(ti_widget_checkbox_GPO3_5);
    };
    templateObj.$.ti_widget_checkbox_GPO3_6.onclick = function() {
        GPO3_send(ti_widget_checkbox_GPO3_6);
    };
    templateObj.$.ti_widget_checkbox_GPO3_7.onclick = function() {
        GPO3_send(ti_widget_checkbox_GPO3_7);
    };
    templateObj.$.ti_widget_checkbox_GPO3_8.onclick = function() {
        GPO3_send(ti_widget_checkbox_GPO3_8);
    };
    
    
    
    templateObj.$.ti_widget_checkbox_GPO4.onclick = function() {
        GPO4_send(ti_widget_checkbox_GPO4);
    };
    templateObj.$.ti_widget_checkbox_GPO4_2.onclick = function() {
        GPO4_send(ti_widget_checkbox_GPO4_2);
    };
    templateObj.$.ti_widget_checkbox_GPO4_3.onclick = function() {
        GPO4_send(ti_widget_checkbox_GPO4_3);
    };
    templateObj.$.ti_widget_checkbox_GPO4_4.onclick = function() {
        GPO4_send(ti_widget_checkbox_GPO4_4);
    };
    templateObj.$.ti_widget_checkbox_GPO4_5.onclick = function() {
        GPO4_send(ti_widget_checkbox_GPO4_5);
    };
    templateObj.$.ti_widget_checkbox_GPO4_6.onclick = function() {
        GPO4_send(ti_widget_checkbox_GPO4_6);
    };
    templateObj.$.ti_widget_checkbox_GPO4_7.onclick = function() {
        GPO4_send(ti_widget_checkbox_GPO4_7);
    };
    templateObj.$.ti_widget_checkbox_GPO4_8.onclick = function() {
        GPO4_send(ti_widget_checkbox_GPO4_8);
    };
    

    
    templateObj.$.ti_widget_droplist_PGA.onchange = function() {
    	console.log(ti_widget_droplist_PGA.selectedValue + ' PGAs');
    	
        newCommand = "p" + ti_widget_droplist_PGA.selectedValue;
        newCommand = newCommand + "\r";
        templateObj.$.ti_model_streaming.sendValue(newCommand);
        
        windowVis();
        
        
    };
    
    templateObj.$.ti_widget_checkbox_ZCEN.onclick = function() {
    	if (this.checked === true)
        {
        console.log('Zero Crossing Enabled');
        newCommand = 'zce';
        }
        else
        {
        console.log('Zero Crossing Disabled');
        newCommand = 'zcd';
        }
        
        newCommand = newCommand + "\r";
        templateObj.$.ti_model_streaming.sendValue(newCommand); //use this instead of sendComm because only pga1 is valid
        //sendComm(newCommand);
    };

        },1);

	});
};

templateObj = document.querySelector('#template_obj');
if (templateObj) {
    init();
} else {
    document.addEventListener('DOMContentLoaded',init.bind(this))
}


DC_send = function(widget) {
    if (widget.checked === true)
        {
        console.log('DCcHECKed');
        newCommand = 'dce';
        }
        else
        {
        console.log('DCnotCHECKed');
        newCommand = 'dcd';
        }
        
        sendComm(newCommand);
};

CM_send = function(widget) {
    if (widget.checked === true)
        {
        console.log('CMcHECKed');
        newCommand = 'cme';
        }
        else
        {
        console.log('CMnotCHECKed');
        newCommand = 'cmd';
        }
        
        sendComm(newCommand);
};

Overload_send = function(widget) {
    if (widget.selectedText === "5.1V")
        {
        newCommand = 'ovd';
        }
        if (widget.selectedText === "4.0V")
        {
        newCommand = 'ove';
        }
        
        sendComm(newCommand);
};

GPO1_send = function(widget){
    if (widget.checked === true)
        {
        console.log('GPO1 High');
        newCommand = 'gp1e';
        }
        else
        {
        console.log('GPO1 Low');
        newCommand = 'gp1d';
        }
        
        sendComm(newCommand);
};

GPO2_send = function(widget){
    if (widget.checked === true)
        {
        console.log('GPO2 High');
        newCommand = 'gp2e';
        }
        else
        {
        console.log('GPO2 Low');
        newCommand = 'gp2d';
        }
        
        sendComm(newCommand);
};

GPO3_send = function(widget){
    if (widget.checked === true)
        {
        console.log('GPO3 High');
        newCommand = 'gp3e';
        }
        else
        {
        console.log('GPO3 Low');
        newCommand = 'gp3d';
        }
        
        sendComm(newCommand);
};

GPO4_send = function(widget){
    if (widget.checked === true)
        {
        console.log('GPO4 High');
        newCommand = 'gp4e';
        }
        else
        {
        console.log('GPO4 Low');
        newCommand = 'gp4d';
        }
        
        sendComm(newCommand);
};

sendComm = function(command){
    
    
    if (ti_widget_droplist_PGA.selectedValue >1){
        var selected = ti_widget_tabcontainer.selectedIndex + 1;
        command = command + "p" + selected;
        
    }
    
    command = command + "\r";
    templateObj.$.ti_model_streaming.sendValue(command);
    
};

windowVis = function() {
    	    var i = templateObj.$.ti_widget_droplist_PGA.selectedValue;
        
            if(i >= 2) {templateObj.$.ti_widget_tab_PGA2.hidden = false;}
            else {templateObj.$.ti_widget_tab_PGA2.hidden = true;}
            if(i >= 3) {templateObj.$.ti_widget_tab_PGA3.hidden = false;}
            else {templateObj.$.ti_widget_tab_PGA3.hidden = true;}
            if(i >= 4) {templateObj.$.ti_widget_tab_PGA4.hidden = false;}
            else {templateObj.$.ti_widget_tab_PGA4.hidden = true;}
            if(i >= 5) {templateObj.$.ti_widget_tab_PGA5.hidden = false;}
            else {templateObj.$.ti_widget_tab_PGA5.hidden = true;}
            if(i >= 6) {templateObj.$.ti_widget_tab_PGA6.hidden = false;}
            else {templateObj.$.ti_widget_tab_PGA6.hidden = true;}
            if(i >= 7) {templateObj.$.ti_widget_tab_PGA7.hidden = false;}
            else {templateObj.$.ti_widget_tab_PGA7.hidden = true;}
            if(i >= 8) {templateObj.$.ti_widget_tab_PGA8.hidden = false;}
            else {templateObj.$.ti_widget_tab_PGA8.hidden = true;}
};

console.log('TEST GOOD');

